Paragraph format in EJ2 JavaScript Document editor control

15 Feb 202514 minutes to read

Document Editor supports various paragraph formatting options such as text alignment, indentation, paragraph spacing, and more.

Indentation

You can modify the left or right indentation of selected paragraphs using the following sample code.

documenteditor.selection.paragraphFormat.leftIndent = 24;
documenteditor.selection.paragraphFormat.rightIndent = 24;

Special indentation

You can define special indent for first line of the paragraph using the following sample code.

documenteditor.selection.paragraphFormat.firstLineIndent = 24;

Increase indent

You can increase the left indent of selected paragraphs by a factor of 36 points using the following sample code.

documenteditor.editor.increaseIndent()

Decrease indent

You can decrease the left indent of selected paragraphs by a factor of 36 points using the following sample code.

documenteditor.editor.decreaseIndent()

Text alignment

You can get or set the text alignment of selected paragraphs using the following sample code.

documenteditor.selection.paragraphFormat.textAlignment = 'Center' | 'Left' | 'Right' | 'Justify';

Note: Starting from v19.4.0.x, the text justification of Document editor component matches alignment of Microsoft Word 2013 and newer versions based on the compatibility mode present in the document. The DOCX document created using Microsoft Word 2013 and newer versions will have the compatibility mode Word2013 and follows a special behavior in justifying the text. You can retain the text justification behavior like old versions by modifying the compatibility mode as Word2010.

documenteditor.documentSettings.compatibilityMode = 'Word2010';

Note: The Document editor component assumes the compatibility mode as Word2013 by default, if it is not defined for a document.

Image

You can toggle the text alignment of selected paragraphs by specifying a value using the following sample code.

documenteditor.editor.toggleTextAlignment('Center' | 'Left' | 'Right' | 'Justify');

Line spacing and its type

You can define the line spacing and its type for selected paragraphs using the following sample code.

documenteditor.selection.paragraphFormat.lineSpacingType = 'AtLeast';
documenteditor.selection.paragraphFormat.lineSpacing = 6;

Paragraph spacing

You can define the spacing before or after the paragraph by using the following sample code.

documenteditor.selection.paragraphFormat.beforeSpacing = 24;
documenteditor.selection.paragraphFormat.afterSpacing = 24;

You can also set automatic spacing before and after the paragraph by using the following sample code.

documenteditor.selection.paragraphFormat.spaceBeforeAuto = true;
documenteditor.selection.paragraphFormat.spaceAfterAuto = true;

Note: If auto spacing property is enabled, then value defined in the beforeSpacing and afterSpacing property will not be considered.

Pagination properties

You can enable or disable the following pagination properties for the paragraphs in a Word document.

  • Widow/Orphan control - whether the first and last lines of the paragraph are to remain on the same page as the rest of the paragraph when paginating the document.
  • Keep with next - whether the specified paragraph remains on the same page as the paragraph that follows it while paginating the document.
  • Keep lines together - whether all lines in the specified paragraphs remain on the same page while paginating the document.

The following example code illustrates how to enable or disable these pagination properties for the selected paragraphs.

documenteditor.selection.paragraphFormat.widowControl = false;
documenteditor.selection.paragraphFormat.keepWithNext = true;
documenteditor.selection.paragraphFormat.keepLinesTogether = true;

Paragraph Border

You can apply borders to the paragraphs in a Word document. Using borders, decorate the paragraphs to set them apart from other paragraphs in the document.

The following example code illustrates how to apply box border for the selected paragraphs.

// left
documenteditor.selection.paragraphFormat.borders.left.lineStyle = 'Single';
documenteditor.selection.paragraphFormat.borders.left.lineWidth = 3;
documenteditor.selection.paragraphFormat.borders.left.color = "#000000";

//right
documenteditor.selection.paragraphFormat.borders.right.lineStyle = 'Single';
documenteditor.selection.paragraphFormat.borders.right.lineWidth = 3;
documenteditor.selection.paragraphFormat.borders.right.color = "#000000";

//top
documenteditor.selection.paragraphFormat.borders.top.lineStyle = 'Single';
documenteditor.selection.paragraphFormat.borders.top.lineWidth = 3;
documenteditor.selection.paragraphFormat.borders.top.color = "#000000";

//bottom
documenteditor.selection.paragraphFormat.borders.bottom.lineStyle = 'Single';
documenteditor.selection.paragraphFormat.borders.bottom.lineWidth = 3;
documenteditor.selection.paragraphFormat.borders.bottom.color = "#000000";

Note: At present, the Document editor component displays all the border styles as single line. But you can apply any border style and get the proper display in Microsoft Word app when opening the exported Word document.

Show or Hide Paragraph marks

You can show or hide the hidden formatting symbols like spaces, tab, paragraph marks, and breaks in Document editor component. These marks help identify the start and end of a paragraph and all the hidden formatting symbols in a Word document.

The following example code illustrates how to show or hide paragraph marks.

documenteditor.documentEditorSettings.showHiddenMarks = true;

Toolbar with paragraph formatting options

The following sample demonstrates the paragraph formatting options using a toolbar.

var documenteditor = new ej.documenteditor.DocumentEditor({
  isReadOnly: false, enableSelection: true, enableEditorHistory: true, enableEditor: true, enableContextMenu: true, enableSfdtExport: true,height: '370px'
});
function toolbarButtonClick(arg) {
  switch (arg.item.id) {
    case 'AlignLeft':
      //Toggle the Left alignment for selected or current paragraph
      documenteditor.editor.toggleTextAlignment('Left');
      break;
    case 'AlignRight':
      //Toggle the Right alignment for selected or current paragraph
      documenteditor.editor.toggleTextAlignment('Right');
      break;
    case 'AlignCenter':
      //Toggle the Center alignment for selected or current paragraph
      documenteditor.editor.toggleTextAlignment('Center');
      break;
    case 'Justify':
      //Toggle the Justify alignment for selected or current paragraph
      documenteditor.editor.toggleTextAlignment('Justify');
      break;
    case 'IncreaseIndent':
      //Increase the left indent of selected or current paragraph
      documenteditor.editor.increaseIndent();
      break;
    case 'DecreaseIndent':
      //Decrease the left indent of selected or current paragraph
      documenteditor.editor.decreaseIndent();
      break;
    case 'ClearFormat':
      documenteditor.editor.clearFormatting();
      break;
  }
}
//Change the line spacing of selected or current paragraph
function lineSpacingAction(args) {
  var text = args.item.text;
  switch (text) {
    case 'Single':
      documenteditor.selection.paragraphFormat.lineSpacing = 1;
      break;
    case '1.15':
      documenteditor.selection.paragraphFormat.lineSpacing = 1.15;
      break;
    case '1.5':
      documenteditor.selection.paragraphFormat.lineSpacing = 1.5;
      break;
    case 'Double':
      documenteditor.selection.paragraphFormat.lineSpacing = 2;
      break;
  }
  setTimeout(function () {
    documenteditor.focusIn();
  }, 30);
}
documenteditor.selectionChange = () => {
  setTimeout(() => {
    onSelectionChange();
  }, 20);
};
// Selection change to retrieve formatting
function onSelectionChange() {
  if (documenteditor.selection) {
    var paragraphFormat = documenteditor.selection.paragraphFormat;
    var toggleBtnId = ['AlignLeft', 'AlignCenter', 'AlignRight', 'Justify'];
    for (var i = 0; i < toggleBtnId.length; i++) {
      var toggleBtn = document.getElementById(
        toggleBtnId[i]
      );
      toggleBtn.classList.remove('e-btn-toggle');
    }
    if (paragraphFormat.textAlignment === 'Left') {
      document.getElementById('AlignLeft').classList.add('e-btn-toggle');
    } else if (paragraphFormat.textAlignment === 'Right') {
      document.getElementById('AlignRight').classList.add('e-btn-toggle');
    } else if (paragraphFormat.textAlignment === 'Center') {
      document
        .getElementById('AlignCenter')
        .classList.add('e-btn-toggle');
    } else {
      document.getElementById('Justify').classList.add('e-btn-toggle');
    }
    // #endregion
  }
}
//Toolbar configuration to add paragraph formatting options
var toolBar = new ej.navigations.Toolbar({
  clicked: toolbarButtonClick,
  items: [
    {
      prefixIcon: 'e-de-ctnr-alignleft e-icons',
      tooltipText: 'Align Left',
      id: 'AlignLeft',
    },
    {
      prefixIcon: 'e-de-ctnr-aligncenter e-icons',
      tooltipText: 'Align Center',
      id: 'AlignCenter',
    },
    {
      prefixIcon: 'e-de-ctnr-alignright e-icons',
      tooltipText: 'Align Right',
      id: 'AlignRight',
    },
    {
      prefixIcon: 'e-de-ctnr-justify e-icons',
      tooltipText: 'Justify',
      id: 'Justify',
    },
    {
      prefixIcon: 'e-de-ctnr-increaseindent e-icons',
      tooltipText: 'Increase Indent',
      id: 'IncreaseIndent',
    },
    {
      prefixIcon: 'e-de-ctnr-decreaseindent e-icons',
      tooltipText: 'Decrease Indent',
      id: 'DecreaseIndent',
    },
    { type: 'Separator' },
    {
      id: 'lineSpacing',
    }, {
      prefixIcon: 'e-de-ctnr-clearall e-icons',
      tooltipText: 'ClearFormatting',
      id: 'ClearFormat',
    }
  ],
});
toolBar.appendTo('#toolbar');
var items = [
  {
    text: 'Single',
  },
  {
    text: '1.15',
  },
  {
    text: '1.5',
  },
  {
    text: 'Double',
  },
];
var dropdown = new ej.splitbuttons.DropDownButton({
  items: items,
  iconCss: 'e-de-ctnr-linespacing e-icons',
  select: lineSpacingAction,
});
dropdown.appendTo('#lineSpacing');

documenteditor.appendTo('#DocumentEditor');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-documenteditor/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-buttons/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-base/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-dropdowns/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-inputs/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-lists/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-navigations/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-popups/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-splitbuttons/styles/fabric.css" rel="stylesheet"> 
    
    
<script src="https://cdn.syncfusion.com/ej2/29.1.33/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="toolbar">            
        </div>
        <div style="width:100%;height: 100%">
            <!--Element which will render as DocumentEditor -->
            <div id="DocumentEditor"></div>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See Also

Paragraph format in Angular Document editor component

28 Mar 202515 minutes to read

Document Editor supports various paragraph formatting options such as text alignment, indentation, paragraph spacing, and more.

Indentation

You can modify the left or right indentation of selected paragraphs using the following sample code.

this.documentEditor.selection.paragraphFormat.leftIndent= 24;
this.documentEditor.selection.paragraphFormat.rightIndent= 24;

Special indentation

You can define special indent for first line of the paragraph using the following sample code.

this.documentEditor.selection.paragraphFormat.firstLineIndent= 24;

Increase indent

You can increase the left indent of selected paragraphs by a factor of 36 points using the following sample code.

this.documentEditor.editor.increaseIndent();

Decrease indent

You can decrease the left indent of selected paragraphs by a factor of 36 points using the following sample code.

this.documentEditor.editor.decreaseIndent();

Text alignment

You can get or set the text alignment of selected paragraphs using the following sample code.

this.documentEditor.selection.paragraphFormat.textAlignment= 'Center' | 'Left' | 'Right' | 'Justify';

You can toggle the text alignment of selected paragraphs by specifying a value using the following sample code.

this.documentEditor.editor.toggleTextAlignment('Center' | 'Left' | 'Right' | 'Justify');

Line spacing and its type

You can define the line spacing and its type for selected paragraphs using the following sample code.

this.documentEditor.selection.paragraphFormat.lineSpacingType='AtLeast';
this.documentEditor.selection.paragraphFormat.lineSpacing= 6;

Paragraph spacing

You can define the spacing before or after the paragraph by using the following sample code.

this.documentEditor.selection.paragraphFormat.beforeSpacing= 24;
this.documentEditor.selection.paragraphFormat.afterSpacing= 24;

You can also set automatic spacing before and after the paragraph by using the following sample code.

this.documentEditor.selection.paragraphFormat.spaceBeforeAuto = true;
this.documentEditor.selection.paragraphFormat.spaceAfterAuto = true;

Note: If auto spacing property is enabled, then value defined in the beforeSpacing and afterSpacing property will not be considered.

Pagination properties

You can enable or disable the following pagination properties for the paragraphs in a Word document.

  • Widow/Orphan control - whether the first and last lines of the paragraph are to remain on the same page as the rest of the paragraph when paginating the document.
  • Keep with next - whether the specified paragraph remains on the same page as the paragraph that follows it while paginating the document.
  • Keep lines together - whether all lines in the specified paragraphs remain on the same page while paginating the document.

The following example code illustrates how to enable or disable these pagination properties for the selected paragraphs.

this.documenteditor.selection.paragraphFormat.widowControl = false;
this.documenteditor.selection.paragraphFormat.keepWithNext = true;
this.documenteditor.selection.paragraphFormat.keepLinesTogether = true;

Paragraph Border

You can apply borders to the paragraphs in a Word document. Using borders, decorate the paragraphs to set them apart from other paragraphs in the document.

The following example code illustrates how to apply box border for the selected paragraphs.

// left
this.documenteditor.selection.paragraphFormat.borders.left.lineStyle = 'Single';
this.documenteditor.selection.paragraphFormat.borders.left.lineWidth = 3;
this.documenteditor.selection.paragraphFormat.borders.left.color = "#000000";

//right
this.documenteditor.selection.paragraphFormat.borders.right.lineStyle = 'Single';
this.documenteditor.selection.paragraphFormat.borders.right.lineWidth = 3;
this.documenteditor.selection.paragraphFormat.borders.right.color = "#000000";

//top
this.documenteditor.selection.paragraphFormat.borders.top.lineStyle = 'Single';
this.documenteditor.selection.paragraphFormat.borders.top.lineWidth = 3;
this.documenteditor.selection.paragraphFormat.borders.top.color = "#000000";

//bottom
this.documenteditor.selection.paragraphFormat.borders.bottom.lineStyle = 'Single';
this.documenteditor.selection.paragraphFormat.borders.bottom.lineWidth = 3;
this.documenteditor.selection.paragraphFormat.borders.bottom.color = "#000000";

Note: At present, the Document editor component displays all the border styles as single line. But you can apply any border style and get the proper display in Microsoft Word app when opening the exported Word document.

Show or Hide Paragraph marks

You can show or hide the hidden formatting symbols like spaces, tab, paragraph marks, and breaks in Document editor component. These marks help identify the start and end of a paragraph and all the hidden formatting symbols in a Word document.

The following example code illustrates how to show or hide paragraph marks.

this.documenteditor.documentEditorSettings.showHiddenMarks = true;

Toolbar with paragraph formatting options

The following sample demonstrates the paragraph formatting options using a toolbar.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { DocumentEditorAllModule } from '@syncfusion/ej2-angular-documenteditor'
import { ToolbarModule } from '@syncfusion/ej2-angular-navigations'
import { ComboBoxModule } from '@syncfusion/ej2-angular-dropdowns'
import {ColorPickerModule } from '@syncfusion/ej2-angular-inputs'



import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
    DocumentEditorComponent, EditorService, SelectionService, EditorHistoryService, SfdtExportService, ContextMenuService
} from '@syncfusion/ej2-angular-documenteditor';

@Component({
imports: [
        
        ButtonModule,
        ToolbarModule,
        DocumentEditorAllModule,
        ComboBoxModule,
        ColorPickerModule
    ],


standalone: true,
    selector: 'app-container',
    styleUrls: ['./style.css'],
    //specifies the template string for the Document Editor component
    template: `<div>
    <div>
        <ejs-toolbar (clicked)='toolbarButtonClick($event)'>
            <e-items>
                <e-item prefixIcon='e-de-ctnr-alignleft e-icons' id='AlignLeft' tooltipText='Align Left'></e-item>
                <e-item prefixIcon='e-de-ctnr-aligncenter e-icons' id='AlignCenter' tooltipText='AlignCenter'></e-item>
                <e-item prefixIcon='e-de-ctnr-alignright e-icons' id='AlignRight' tooltipText='AlignRight'></e-item>
                <e-item prefixIcon='e-de-ctnr-justify e-icons' id='Justify' tooltipText='Justify'></e-item>
                <e-item prefixIcon='e-de-ctnr-increaseindent e-icons' id='IncreaseIndent' tooltipText='Increase Indent'></e-item>
                <e-item prefixIcon='e-de-ctnr-decreaseindent e-icons' id='DecreaseIndent' tooltipText='Decrease Indent'></e-item>
                <e-item type='Separator'></e-item>
                <e-item prefixIcon='e-de-ctnr-clearall e-icons' id='ClearFormat' tooltipText='ClearFormatting'></e-item>
                <e-item type='Separator'></e-item>
                <e-item prefixIcon='e-de-e-paragraph-mark e-icons' id='ShowParagraphMark' tooltipText='Show the hidden characters like spaces, tab, paragraph marks, and breaks.(Ctrl + *)'></e-item>
            </e-items>
        </ejs-toolbar>
      </div>
      <ejs-documenteditor #document_editor (selectionChange)='onSelectionChange()' [enableSelection]='true' [isReadOnly]='false' [enableEditor]=true [enableEditorHistory]=true [enableSfdtExport]=true [enableContextMenu]=true height="330px" style="display:block"></ejs-documenteditor>
    </div>`,
    encapsulation: ViewEncapsulation.None,
    providers: [EditorService, SelectionService, EditorHistoryService, SfdtExportService, ContextMenuService]
})
export class AppComponent {
    @ViewChild('document_editor')
    public documentEditor?: DocumentEditorComponent;

    public toolbarButtonClick(arg: any) {
        switch (arg.item.id) {
            case 'AlignLeft':
                //Toggle the Left alignment for selected or current paragraph
                (this.documentEditor as DocumentEditorComponent).editor.toggleTextAlignment('Left');
                break;
            case 'AlignRight':
                //Toggle the Right alignment for selected or current paragraph
                (this.documentEditor as DocumentEditorComponent).editor.toggleTextAlignment('Right');
                break;
            case 'AlignCenter':
                //Toggle the Center alignment for selected or current paragraph
                (this.documentEditor as DocumentEditorComponent).editor.toggleTextAlignment('Center');
                break;
            case 'Justify':
                //Toggle the Justify alignment for selected or current paragraph
                (this.documentEditor as DocumentEditorComponent).editor.toggleTextAlignment('Justify');
                break;
            case 'IncreaseIndent':
                //Increase the left indent of selected or current paragraph
                (this.documentEditor as DocumentEditorComponent).editor.increaseIndent();
                break;
            case 'DecreaseIndent':
                //Decrease the left indent of selected or current paragraph
                (this.documentEditor as DocumentEditorComponent).editor.decreaseIndent();
                break;
            case 'ClearFormat':
                //Clear formatting for selected paragraph or content.
                (this.documentEditor as DocumentEditorComponent).editor.clearFormatting();
                break;
            case 'ShowParagraphMark':
                //Show or hide the hidden characters like spaces, tab, paragraph marks, and breaks.
                (this.documentEditor as DocumentEditorComponent).documentEditorSettings.showHiddenMarks = !(this.documentEditor as DocumentEditorComponent).documentEditorSettings.showHiddenMarks;
                break;
        }
    }

    // Selection change to retrieve formatting
    public onSelectionChange() {
        if ((this.documentEditor as DocumentEditorComponent).selection) {
            var paragraphFormat = (this.documentEditor as DocumentEditorComponent).selection.paragraphFormat;
            var toggleBtnId = ['AlignLeft', 'AlignCenter', 'AlignRight', 'Justify', 'ShowParagraphMark'];
            //Remove toggle state.
            if (document.getElementById('AlignLeft')) {
              for (var i = 0; i < toggleBtnId.length; i++) {
                let toggleBtn: HTMLElement = document.getElementById(toggleBtnId[i]) as HTMLElement;
                toggleBtn.classList.remove('e-btn-toggle');
              }
              //Add toggle state based on selection paragraph format.
              if (paragraphFormat.textAlignment === 'Left') {
                (document.getElementById('AlignLeft') as HTMLElement).classList.add('e-btn-toggle');
              } else if (paragraphFormat.textAlignment === 'Right') {
                (document.getElementById('AlignRight') as HTMLElement).classList.add('e-btn-toggle');
              } else if (paragraphFormat.textAlignment === 'Center') {
                (document.getElementById('AlignCenter') as HTMLElement).classList.add('e-btn-toggle');
              } else {
                (document.getElementById('Justify') as HTMLElement).classList.add('e-btn-toggle');
              }
              if ((this.documentEditor as DocumentEditorComponent).documentEditorSettings.showHiddenMarks) {
                (document.getElementById('ShowParagraphMark') as HTMLElement).classList.add('e-btn-toggle');
              }
            }
            // #endregion
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

See Also

Paragraph format in React Document editor component

29 Mar 202518 minutes to read

Document Editor supports various paragraph formatting options such as text alignment, indentation, paragraph spacing, and more.

Indentation

You can modify the left or right indentation of selected paragraphs using the following sample code.

documenteditor.selection.paragraphFormat.leftIndent= 24;
documenteditor.selection.paragraphFormat.rightIndent= 24;

Special indentation

You can define special indent for first line of the paragraph using the following sample code.

documenteditor.selection.paragraphFormat.firstLineIndent= 24;

Increase indent

You can increase the left indent of selected paragraphs by a factor of 36 points using the following sample code.

documenteditor.editor.increaseIndent()

Decrease indent

You can decrease the left indent of selected paragraphs by a factor of 36 points using the following sample code.

documenteditor.editor.decreaseIndent()

Text alignment

You can get or set the text alignment of selected paragraphs using the following sample code.

documenteditor.selection.paragraphFormat.textAlignment= 'Center' | 'Left' | 'Right' | 'Justify';

You can toggle the text alignment of selected paragraphs by specifying a value using the following sample code.

documenteditor.editor.toggleTextAlignment('Center' | 'Left' | 'Right' | 'Justify');

Line spacing and its type

You can define the line spacing and its type for selected paragraphs using the following sample code.

documenteditor.selection.paragraphFormat.lineSpacingType='AtLeast';
documenteditor.selection.paragraphFormat.lineSpacing= 6;

Paragraph spacing

You can define the spacing before or after the paragraph by using the following sample code.

documenteditor.selection.paragraphFormat.beforeSpacing= 24;
documenteditor.selection.paragraphFormat.afterSpacing= 24;

You can also set automatic spacing before and after the paragraph by using the following sample code.

documenteditor.selection.paragraphFormat.spaceBeforeAuto = true;
documenteditor.selection.paragraphFormat.spaceAfterAuto = true;

Note: If auto spacing property is enabled, then value defined in the beforeSpacing and afterSpacing property will not be considered.

Paragraph Border

You can apply borders to the paragraphs in a Word document. Using borders, decorate the paragraphs to set them apart from other paragraphs in the document.

The following example code illustrates how to apply box border for the selected paragraphs.

// left
documenteditor.selection.paragraphFormat.borders.left.lineStyle = 'Single';
documenteditor.selection.paragraphFormat.borders.left.lineWidth = 3;
documenteditor.selection.paragraphFormat.borders.left.color = "#000000";

//right
documenteditor.selection.paragraphFormat.borders.right.lineStyle = 'Single';
documenteditor.selection.paragraphFormat.borders.right.lineWidth = 3;
documenteditor.selection.paragraphFormat.borders.right.color = "#000000";

//top
documenteditor.selection.paragraphFormat.borders.top.lineStyle = 'Single';
documenteditor.selection.paragraphFormat.borders.top.lineWidth = 3;
documenteditor.selection.paragraphFormat.borders.top.color = "#000000";

//bottom
documenteditor.selection.paragraphFormat.borders.bottom.lineStyle = 'Single';
documenteditor.selection.paragraphFormat.borders.bottom.lineWidth = 3;
documenteditor.selection.paragraphFormat.borders.bottom.color = "#000000";

Note: At present, the Document editor component displays all the border styles as single line. But you can apply any border style and get the proper display in Microsoft Word app when opening the exported Word document.

Pagination properties

You can enable or disable the following pagination properties for the paragraphs in a Word document.

  • Widow/Orphan control - whether the first and last lines of the paragraph are to remain on the same page as the rest of the paragraph when paginating the document.
  • Keep with next - whether the specified paragraph remains on the same page as the paragraph that follows it while paginating the document.
  • Keep lines together - whether all lines in the specified paragraphs remain on the same page while paginating the document.

The following example code illustrates how to enable or disable these pagination properties for the selected paragraphs.

documenteditor.selection.paragraphFormat.widowControl = false;
documenteditor.selection.paragraphFormat.keepWithNext = true;
documenteditor.selection.paragraphFormat.keepLinesTogether = true;

Show or Hide Paragraph marks

You can show or hide the hidden formatting symbols like spaces, tab, paragraph marks, and breaks in Document editor component. These marks help identify the start and end of a paragraph and all the hidden formatting symbols in a Word document.

The following example code illustrates how to show or hide paragraph marks.

documenteditor.documentEditorSettings.showHiddenMarks = true;

Toolbar with paragraph formatting options

The following sample demonstrates the paragraph formatting options using a toolbar.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import {
    DocumentEditorComponent, Selection, Editor, EditorHistory, ContextMenu
} from '@syncfusion/ej2-react-documenteditor';
import { ToolbarComponent, ItemsDirective, ItemDirective } from '@syncfusion/ej2-react-navigations';
import { DropDownButtonComponent, ItemModel } from '@syncfusion/ej2-react-splitbuttons';

//Inject require modules.
DocumentEditorComponent.Inject(Selection, Editor, EditorHistory, ContextMenu);
function App() {
    let documenteditor: DocumentEditorComponent;
    React.useEffect(() => {
        componentDidMount()
    }, []);
    let items: ItemModel[] = [
        {
            text: 'Single',
        },
        {
            text: '1.15',
        },
        {
            text: '1.5',
        },
        {
            text: 'Double',
        },
    ];

    function contentTemplate1() {
        return (<DropDownButtonComponent items={items} iconCss="e-de-icon-LineSpacing" select={lineSpacingAction} ></DropDownButtonComponent>);
    }
    function componentDidMount(): void {
        documenteditor.selectionChange = () => {
            setTimeout(() => { onSelectionChange(); }, 20);
        };
    }

    function toolbarButtonClick(arg): void {
        switch (arg.item.id) {
            case 'AlignLeft':
                //Toggle the Left alignment for selected or current paragraph
                documenteditor.editor.toggleTextAlignment('Left');
                break;
            case 'AlignRight':
                //Toggle the Right alignment for selected or current paragraph
                documenteditor.editor.toggleTextAlignment('Right');
                break;
            case 'AlignCenter':
                //Toggle the Center alignment for selected or current paragraph
                documenteditor.editor.toggleTextAlignment('Center');
                break;
            case 'Justify':
                //Toggle the Justify alignment for selected or current paragraph
                documenteditor.editor.toggleTextAlignment('Justify');
                break;
            case 'IncreaseIndent':
                //Increase the left indent of selected or current paragraph
                documenteditor.editor.increaseIndent();
                break;
            case 'DecreaseIndent':
                //Decrease the left indent of selected or current paragraph
                documenteditor.editor.decreaseIndent();
                break;
            case 'ClearFormat':
                documenteditor.editor.clearFormatting();
                break;
            case 'ShowParagraphMark':
                //Show or hide the hidden characters like spaces, tab, paragraph marks, and breaks.
                documenteditor.documentEditorSettings.showHiddenMarks = !documenteditor.documentEditorSettings.showHiddenMarks;
                break;
        }
    }
    //Change the line spacing of selected or current paragraph
    function lineSpacingAction(args: any) {
        let text: string = args.item.text;
        switch (text) {
            case 'Single':
                documenteditor.selection.paragraphFormat.lineSpacing = 1;
                break;
            case '1.15':
                documenteditor.selection.paragraphFormat.lineSpacing = 1.15;
                break;
            case '1.5':
                documenteditor.selection.paragraphFormat.lineSpacing = 1.5;
                break;
            case 'Double':
                documenteditor.selection.paragraphFormat.lineSpacing = 2;
                break;
        }
        setTimeout((): void => {
            documenteditor.focusIn();
        }, 30);
    }
    // Selection change to retrieve formatting
    function onSelectionChange() {
        if (documenteditor.selection) {
            var paragraphFormat = documenteditor.selection.paragraphFormat;
            var toggleBtnId = ['AlignLeft', 'AlignCenter', 'AlignRight', 'Justify', 'ShowParagraphMark'];
            //Remove toggle state.
            for (var i = 0; i < toggleBtnId.length; i++) {
                let toggleBtn: HTMLElement = document.getElementById(toggleBtnId[i]);
                toggleBtn.classList.remove('e-btn-toggle');
            }
            //Add toggle state based on selection paragraph format.
            if (paragraphFormat.textAlignment === 'Left') {
                document.getElementById('AlignLeft').classList.add('e-btn-toggle');
            } else if (paragraphFormat.textAlignment === 'Right') {
                document.getElementById('AlignRight').classList.add('e-btn-toggle');
            } else if (paragraphFormat.textAlignment === 'Center') {
                document.getElementById('AlignCenter').classList.add('e-btn-toggle');
            } else {
                document.getElementById('Justify').classList.add('e-btn-toggle');
            }
            if (documenteditor.documentEditorSettings.showHiddenMarks) {
                document.getElementById('ShowParagraphMark').classList.add('e-btn-toggle');
            }
            // #endregion
        }
    }

    return (
        <div>
            <ToolbarComponent id='toolbar' clicked={toolbarButtonClick}>
                <ItemsDirective>
                    <ItemDirective id="AlignLeft" prefixIcon="e-de-ctnr-alignleft e-icons" tooltipText="Align Left" />
                    <ItemDirective id="AlignCenter" prefixIcon="e-de-ctnr-aligncenter e-icons" tooltipText="Align Center" />
                    <ItemDirective id="AlignRight" prefixIcon="e-de-ctnr-alignright e-icons" tooltipText="Align Right" />
                    <ItemDirective id="Justify" prefixIcon="e-de-ctnr-justify e-icons" tooltipText="Justify" />
                    <ItemDirective type="Separator" />
                    <ItemDirective id="IncreaseIndent" prefixIcon="e-de-ctnr-increaseindent e-icons" tooltipText="Increase Indent" />
                    <ItemDirective id="DecreaseIndent" prefixIcon="e-de-ctnr-decreaseindent e-icons" tooltipText="Decrease Indent" />
                    <ItemDirective type="Separator" />
                    <ItemDirective template={contentTemplate1} />
                    <ItemDirective id="ClearFormat" prefixIcon="e-de-ctnr-clearall e-icons" tooltipText="Clear Formatting" />
                    <ItemDirective type="Separator" />
                    <ItemDirective id="ShowParagraphMark" prefixIcon="e-de-e-paragraph-mark e-icons" tooltipText="Show the hidden characters like spaces, tab, paragraph marks, and breaks.(Ctrl + *)" />
                </ItemsDirective>
            </ToolbarComponent>

            <DocumentEditorComponent
                id="container"
                ref={scope => {
                    documenteditor = scope;
                }}
                isReadOnly={false}
                enableSelection={true}
                enableEditor={true}
                enableEditorHistory={true}
                enableContextMenu={true}
                enableTableDialog={true}
                height={'330px'}
            />
        </div>
    );
}
export default App;
ReactDOM.render(<App />, document.getElementById('sample'));

See Also

Paragraph format in Vue Document editor component

11 Jun 202420 minutes to read

Document Editor supports various paragraph formatting options such as text alignment, indentation, paragraph spacing, and more.

Indentation

You can modify the left or right indentation of selected paragraphs using the following sample code.

this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.leftIndent= 24;
this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.rightIndent= 24;

Special indentation

You can define special indent for first line of the paragraph using the following sample code.

this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.firstLineIndent= 24;

Increase indent

You can increase the left indent of selected paragraphs by a factor of 36 points using the following sample code.

this.$refs.documenteditor.ej2Instances.editor.increaseIndent()

Decrease indent

You can decrease the left indent of selected paragraphs by a factor of 36 points using the following sample code.

this.$refs.documenteditor.ej2Instances.editor.decreaseIndent()

Text alignment

You can get or set the text alignment of selected paragraphs using the following sample code.

this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.textAlignment= 'Center' | 'Left' | 'Right' | 'Justify';

You can toggle the text alignment of selected paragraphs by specifying a value using the following sample code.

this.$refs.documenteditor.ej2Instances.editor.toggleTextAlignment('Center' | 'Left' | 'Right' | 'Justify');

Line spacing and its type

You can define the line spacing and its type for selected paragraphs using the following sample code.

//Set line spacing type.
this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.lineSpacingType='AtLeast';

//Set line spacing.
this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.lineSpacing= 6;

Paragraph spacing

You can define the spacing before or after the paragraph by using the following sample code.

//Set before spacing.
this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.beforeSpacing= 24;

//Set after spacing.
this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.afterSpacing= 24;

You can also set automatic spacing before and after the paragraph by using the following sample code.

this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.spaceBeforeAuto = true;
this.$refs.documenteditor.ej2Instances.selection.paragraphFormat.spaceAfterAuto = true;

Note: If auto spacing property is enabled, then value defined in the beforeSpacing and afterSpacing property will not be considered.

Pagination properties

You can enable or disable the following pagination properties for the paragraphs in a Word document.

  • Widow/Orphan control - whether the first and last lines of the paragraph are to remain on the same page as the rest of the paragraph when paginating the document.
  • Keep with next - whether the specified paragraph remains on the same page as the paragraph that follows it while paginating the document.
  • Keep lines together - whether all lines in the specified paragraphs remain on the same page while paginating the document.

The following example code illustrates how to enable or disable these pagination properties for the selected paragraphs.

this.$refs.documenteditor.selection.paragraphFormat.widowControl = false;
this.$refs.documenteditor.selection.paragraphFormat.keepWithNext = true;
this.$refs.documenteditor.selection.paragraphFormat.keepLinesTogether = true;

Paragraph Border

You can apply borders to the paragraphs in a Word document. Using borders, decorate the paragraphs to set them apart from other paragraphs in the document.

The following example code illustrates how to apply box border for the selected paragraphs.

// left
this.$refs.documenteditor.selection.paragraphFormat.borders.left.lineStyle = 'Single';
this.$refs.documenteditor.selection.paragraphFormat.borders.left.lineWidth = 3;
this.$refs.documenteditor.selection.paragraphFormat.borders.left.color = "#000000";

//right
this.$refs.documenteditor.selection.paragraphFormat.borders.right.lineStyle = 'Single';
this.$refs.documenteditor.selection.paragraphFormat.borders.right.lineWidth = 3;
this.$refs.documenteditor.selection.paragraphFormat.borders.right.color = "#000000";

//top
this.$refs.documenteditor.selection.paragraphFormat.borders.top.lineStyle = 'Single';
this.$refs.documenteditor.selection.paragraphFormat.borders.top.lineWidth = 3;
this.$refs.documenteditor.selection.paragraphFormat.borders.top.color = "#000000";

//bottom
this.$refs.documenteditor.selection.paragraphFormat.borders.bottom.lineStyle = 'Single';
this.$refs.documenteditor.selection.paragraphFormat.borders.bottom.lineWidth = 3;
this.$refs.documenteditor.selection.paragraphFormat.borders.bottom.color = "#000000";

Note: At present, the Document editor component displays all the border styles as single line. But you can apply any border style and get the proper display in Microsoft Word app when opening the exported Word document.

Show or Hide Paragraph marks

You can show or hide the hidden formatting symbols like spaces, tab, paragraph marks, and breaks in Document editor component. These marks help identify the start and end of a paragraph and all the hidden formatting symbols in a Word document.

The following example code illustrates how to show or hide paragraph marks.

this.$refs.documenteditor.documentEditorSettings.showHiddenMarks = true;

Toolbar with paragraph formatting options

The following sample demonstrates the paragraph formatting options using a toolbar.

<template>
  <div id="app" style="height:330px">
    <div>
      <ejs-toolbar v-bind:clicked='toolbarButtonClick'>
        <e-items>
          <e-item prefixIcon='e-de-icon-AlignLeft' id='AlignLeft' tooltipText='Align Left'></e-item>
          <e-item prefixIcon='e-de-icon-AlignCenter' id='Align Center' tooltipText='AlignCenter'></e-item>
          <e-item prefixIcon='e-de-icon-AlignRight' id='Align Right' tooltipText='AlignRight'></e-item>
          <e-item prefixIcon='e-de-icon-Justify' id='Justify' tooltipText='Justify'></e-item>
          <e-item prefixIcon='e-de-icon-IncreaseIndent' id='IncreaseIndent' tooltipText='Increase Indent'></e-item>
          <e-item prefixIcon='e-de-icon-DecreaseIndent' id='DecreaseIndent' tooltipText='Decrease Indent'></e-item>
          <e-item type='Separator'></e-item>
          <e-item prefixIcon='e-de-icon-ClearAll' id='ClearFormat' tooltipText='ClearFormatting'></e-item>
          <e-item type='Separator'></e-item>
          <e-item prefixIcon='e-de-e-paragraph-mark e-icons' id='ShowParagraphMark'
            tooltipText='Show the hidden characters like spaces, tab, paragraph marks, and breaks.(Ctrl + *)'></e-item>
        </e-items>
      </ejs-toolbar>
    </div>
    <ejs-documenteditor ref="documenteditor" v-bind:selectionChange='onSelectionChange' :enableSelection='true'
      :isReadOnly='false' :enableEditor='true' :enableEditorHistory='true' :enableSfdtExport='true'
      :enableContextMenu='true' height="370px" style="width: 100%;"></ejs-documenteditor>
  </div>
</template>
<script setup>
import { DocumentEditorComponent as EjsDocumenteditor, Editor, Selection, EditorHistory, SfdtExport, ContextMenu } from '@syncfusion/ej2-vue-documenteditor';
import { ToolbarComponent as EjsToolbar, ItemsDirective as EItems, ItemDirective as EItem } from "@syncfusion/ej2-vue-navigations";
import { provide, ref } from 'vue';

const documenteditor = ref(null);
provide('DocumentEditor', [Editor, Selection, EditorHistory, SfdtExport, ContextMenu])

const toolbarButtonClick = function (arg) {
  switch (arg.item.id) {
    case 'AlignLeft':
      //Toggle the Left alignment for selected or current paragraph
      documenteditor.value.ej2Instances.editor.toggleTextAlignment('Left');
      break;
    case 'AlignRight':
      //Toggle the Right alignment for selected or current paragraph
      documenteditor.value.ej2Instances.editor.toggleTextAlignment('Right');
      break;
    case 'AlignCenter':
      //Toggle the Center alignment for selected or current paragraph
      documenteditor.value.ej2Instances.editor.toggleTextAlignment('Center');
      break;
    case 'Justify':
      //Toggle the Justify alignment for selected or current paragraph
      documenteditor.value.ej2Instances.editor.toggleTextAlignment('Justify');
      break;
    case 'IncreaseIndent':
      //Increase the left indent of selected or current paragraph
      documenteditor.value.ej2Instances.editor.increaseIndent();
      break;
    case 'DecreaseIndent':
      //Decrease the left indent of selected or current paragraph
      documenteditor.value.ej2Instances.editor.decreaseIndent();
      break;
    case 'ClearFormat':
      documenteditor.value.ej2Instances.editor.clearFormatting();
      break;
    case 'ShowParagraphMark':
      //Show or hide the hidden characters like spaces, tab, paragraph marks, and breaks.
      documenteditor.value.ej2Instances.documentEditorSettings.showHiddenMarks = !documenteditor.value.ej2Instances.documentEditorSettings.showHiddenMarks;
      break;
  }
}
const onSelectionChange = function () {
  if (documenteditor.value.ej2Instances.selection) {
    var paragraphFormat = documenteditor.value.ej2Instances.selection.paragraphFormat;
    var toggleBtnId = ['AlignLeft', 'AlignCenter', 'AlignRight', 'Justify', 'ShowParagraphMark'];
    for (var i = 0; i < toggleBtnId.length; i++) {
      let toggleBtn = document.getElementById(toggleBtnId[i]);
      //Remove toggle state.
      toggleBtn.classList.remove('e-btn-toggle');
    }
    //Add toggle state based on selection paragraph format.
    if (paragraphFormat.textAlignment === 'Left') {
      document.getElementById('AlignLeft').classList.add('e-btn-toggle');
    } else if (paragraphFormat.textAlignment === 'Right') {
      document.getElementById('AlignRight').classList.add('e-btn-toggle');
    } else if (paragraphFormat.textAlignment === 'Center') {
      document.getElementById('AlignCenter').classList.add('e-btn-toggle');
    } else {
      document.getElementById('Justify').classList.add('e-btn-toggle');
    }
    if (documenteditor.value.ej2Instances.documentEditorSettings.showHiddenMarks) {
      document.getElementById('ShowParagraphMark').classList.add('e-btn-toggle');
    }
  }
}

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-documenteditor/styles/material.css";
</style>
<template>
  <div id="app" style="height:330px">
    <div>
      <ejs-toolbar v-bind:clicked='toolbarButtonClick'>
        <e-items>
          <e-item prefixIcon='e-de-icon-AlignLeft' id='AlignLeft' tooltipText='Align Left'></e-item>
          <e-item prefixIcon='e-de-icon-AlignCenter' id='Align Center' tooltipText='AlignCenter'></e-item>
          <e-item prefixIcon='e-de-icon-AlignRight' id='Align Right' tooltipText='AlignRight'></e-item>
          <e-item prefixIcon='e-de-icon-Justify' id='Justify' tooltipText='Justify'></e-item>
          <e-item prefixIcon='e-de-icon-IncreaseIndent' id='IncreaseIndent' tooltipText='Increase Indent'></e-item>
          <e-item prefixIcon='e-de-icon-DecreaseIndent' id='DecreaseIndent' tooltipText='Decrease Indent'></e-item>
          <e-item type='Separator'></e-item>
          <e-item prefixIcon='e-de-icon-ClearAll' id='ClearFormat' tooltipText='ClearFormatting'></e-item>
          <e-item type='Separator'></e-item>
          <e-item prefixIcon='e-de-e-paragraph-mark e-icons' id='ShowParagraphMark'
            tooltipText='Show the hidden characters like spaces, tab, paragraph marks, and breaks.(Ctrl + *)'></e-item>
        </e-items>
      </ejs-toolbar>
    </div>
    <ejs-documenteditor ref="documenteditor" v-bind:selectionChange='onSelectionChange' :enableSelection='true'
      :isReadOnly='false' :enableEditor='true' :enableEditorHistory='true' :enableSfdtExport='true'
      :enableContextMenu='true' height="370px" style="width: 100%;"></ejs-documenteditor>
  </div>
</template>
<script>
import { DocumentEditorComponent, Editor, Selection, EditorHistory, SfdtExport, ContextMenu } from '@syncfusion/ej2-vue-documenteditor';
import { ToolbarComponent, ItemDirective, ItemsDirective } from "@syncfusion/ej2-vue-navigations";

export default {
  components: {
    'ejs-documenteditor': DocumentEditorComponent,
    'ejs-toolbar': ToolbarComponent,
    'e-items': ItemsDirective,
    'e-item': ItemDirective
  },
  data: function () {
    return {
    };
  },
  provide: {
    DocumentEditor: [Editor, Selection, EditorHistory, SfdtExport, ContextMenu]
  },
  methods: {
    toolbarButtonClick: function (arg) {
      switch (arg.item.id) {
        case 'AlignLeft':
          //Toggle the Left alignment for selected or current paragraph
          this.$refs.documenteditor.ej2Instances.editor.toggleTextAlignment('Left');
          break;
        case 'AlignRight':
          //Toggle the Right alignment for selected or current paragraph
          this.$refs.documenteditor.ej2Instances.editor.toggleTextAlignment('Right');
          break;
        case 'AlignCenter':
          //Toggle the Center alignment for selected or current paragraph
          this.$refs.documenteditor.ej2Instances.editor.toggleTextAlignment('Center');
          break;
        case 'Justify':
          //Toggle the Justify alignment for selected or current paragraph
          this.$refs.documenteditor.ej2Instances.editor.toggleTextAlignment('Justify');
          break;
        case 'IncreaseIndent':
          //Increase the left indent of selected or current paragraph
          this.$refs.documenteditor.ej2Instances.editor.increaseIndent();
          break;
        case 'DecreaseIndent':
          //Decrease the left indent of selected or current paragraph
          this.$refs.documenteditor.ej2Instances.editor.decreaseIndent();
          break;
        case 'ClearFormat':
          this.$refs.documenteditor.ej2Instances.editor.clearFormatting();
          break;
        case 'ShowParagraphMark':
          //Show or hide the hidden characters like spaces, tab, paragraph marks, and breaks.
          this.$refs.documenteditor.ej2Instances.documentEditorSettings.showHiddenMarks = !this.$refs.documenteditor.ej2Instances.documentEditorSettings.showHiddenMarks;
          break;
      }
    },
    onSelectionChange: function () {
      if (this.$refs.documenteditor.ej2Instances.selection) {
        var paragraphFormat = this.$refs.documenteditor.ej2Instances.selection.paragraphFormat;
        var toggleBtnId = ['AlignLeft', 'AlignCenter', 'AlignRight', 'Justify', 'ShowParagraphMark'];
        for (var i = 0; i < toggleBtnId.length; i++) {
          let toggleBtn = document.getElementById(toggleBtnId[i]);
          //Remove toggle state.
          toggleBtn.classList.remove('e-btn-toggle');
        }
        //Add toggle state based on selection paragraph format.
        if (paragraphFormat.textAlignment === 'Left') {
          document.getElementById('AlignLeft').classList.add('e-btn-toggle');
        } else if (paragraphFormat.textAlignment === 'Right') {
          document.getElementById('AlignRight').classList.add('e-btn-toggle');
        } else if (paragraphFormat.textAlignment === 'Center') {
          document.getElementById('AlignCenter').classList.add('e-btn-toggle');
        } else {
          document.getElementById('Justify').classList.add('e-btn-toggle');
        }
        if (this.$refs.documenteditor.ej2Instances.documentEditorSettings.showHiddenMarks) {
          document.getElementById('ShowParagraphMark').classList.add('e-btn-toggle');
        }
      }
    }
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-documenteditor/styles/material.css";
</style>

See Also